summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorBernhard Voelker <mail@bernhard-voelker.de>2012-08-14 09:22:13 +0200
committerJim Meyering <meyering@redhat.com>2012-08-14 11:34:54 +0200
commit46afefaaa8ea95b5eb63a62792774cd18738234a (patch)
tree4d76b669c082df105808d05af462652923d70258 /tests
parenta07dfa9064bf80b4ceea7048c3104495797a6668 (diff)
downloadcoreutils-46afefaaa8ea95b5eb63a62792774cd18738234a.tar.xz
df: fail when the mount list is required but cannot be read
* src/df.c (main): Add conditions to fail when the mount list cannot be read: this includes the cases when a file name argument is given and any of -a, -l, -t or -x is used. * doc/coreutils.texi: Document the additional error conditions. * tests/df/no-mtab-status: Add a new test. * tests/Makefile.am: Reference the new test. * NEWS: Mention the fix.
Diffstat (limited to 'tests')
-rw-r--r--tests/Makefile.am1
-rwxr-xr-xtests/df/no-mtab-status79
2 files changed, 80 insertions, 0 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index edc04b4fb..273405f59 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -376,6 +376,7 @@ TESTS = \
df/df-P \
df/unreadable \
df/total-unprocessed \
+ df/no-mtab-status \
dd/direct \
dd/misc \
dd/nocache \
diff --git a/tests/df/no-mtab-status b/tests/df/no-mtab-status
new file mode 100755
index 000000000..6e078541f
--- /dev/null
+++ b/tests/df/no-mtab-status
@@ -0,0 +1,79 @@
+#!/bin/sh
+# Test df's behaviour when the mount list cannot be read.
+# This test is skipped on systems that lack LD_PRELOAD support; that's fine.
+
+# Copyright (C) 2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ df
+
+df || skip_ "df fails"
+
+# Simulate "mtab" failure.
+cat > k.c <<'EOF' || framework_failure_
+#include <stdio.h>
+#include <errno.h>
+
+struct mntent *getmntent (FILE *fp)
+{
+ /* Prove that LD_PRELOAD works. */
+ static int done = 0;
+ if (!done)
+ {
+ fclose (fopen ("x", "w"));
+ ++done;
+ }
+ /* Now simulate the failure. */
+ errno = ENOENT;
+ return NULL;
+}
+EOF
+
+# Then compile/link it:
+$CC -shared -fPIC -ldl -O2 k.c -o k.so \
+ || framework_failure_ 'failed to compile with -shared -fPIC'
+
+# Test if LD_PRELOAD works:
+LD_PRELOAD=./k.so df
+test -f x || skip_ "internal test failure: maybe LD_PRELOAD doesn't work?"
+
+# These tests are supposed to succeed:
+LD_PRELOAD=./k.so df '.' || fail=1
+LD_PRELOAD=./k.so df -i '.' || fail=1
+LD_PRELOAD=./k.so df -T '.' || fail=1
+LD_PRELOAD=./k.so df -Ti '.' || fail=1
+LD_PRELOAD=./k.so df --total '.' || fail=1
+
+# These tests are supposed to fail:
+LD_PRELOAD=./k.so df && fail=1
+LD_PRELOAD=./k.so df -i && fail=1
+LD_PRELOAD=./k.so df -T && fail=1
+LD_PRELOAD=./k.so df -Ti && fail=1
+LD_PRELOAD=./k.so df --total && fail=1
+
+LD_PRELOAD=./k.so df -a && fail=1
+LD_PRELOAD=./k.so df -a '.' && fail=1
+
+LD_PRELOAD=./k.so df -l && fail=1
+LD_PRELOAD=./k.so df -l '.' && fail=1
+
+LD_PRELOAD=./k.so df -t hello && fail=1
+LD_PRELOAD=./k.so df -t hello '.' && fail=1
+
+LD_PRELOAD=./k.so df -x hello && fail=1
+LD_PRELOAD=./k.so df -x hello '.' && fail=1
+
+Exit $fail